import java.awt.Rectangle;

/**
 * Ein Rechteck, das manipuliert werden kann und sich selbst auf einer
 * Leinwand zeichnet.
*/

public class Rechteck
{
  private int xgroesse;
  private int ygroesse;
  private int xPosition;
  private int yPosition;
  private String farbe;
  private boolean gefuellt;
  private boolean istSichtbar;

  /**
   * Erzeuge ein neues Rechteck mit einer Standardfarbe an einer Standardposition.
   */
  public Rechteck()
  {
    xgroesse = 30;
    ygroesse = 60;
    xPosition = 0;
    yPosition = 0;
    farbe = "schwarz";
    gefuellt = false;
    istSichtbar = false;
  }
  
  /**
   * Erzeuge ein neues Rechteck mit den angegebenen Werten
   */
  public Rechteck(int xgroesse, int ygroesse , int xPosition, int yPosition, String farbe, boolean gefuellt)
  {
     this.xgroesse    = xgroesse;    
     this.ygroesse    = ygroesse;    
     this.xPosition   = xPosition;
     this.yPosition   = yPosition;
     this.farbe       = farbe;
     this.gefuellt    = gefuellt;
     this.istSichtbar = false;
  }

  /**
   * Mache dieses Rechteck sichtbar. Wenn es bereits sichtbar ist, tue nichts.
   */
  public void sichtbarMachen()
  {
    istSichtbar = true;
    zeichnen();
  }

  /**
   * Mache dieses Rechteck unsichtbar. Wenn es bereits unsichtbar ist, tue nichts.
   */
  public void unsichtbarMachen()
  {
    loeschen();
    istSichtbar = false;
  }


  /*
   * Zeichne dieses Rechteck mit seinen aktuellen Werten auf den Bildschirm.
   */
  private void zeichnen()
  {
    if (istSichtbar)
    {
      Leinwand leinwand = Leinwand.gibLeinwand();
      leinwand.zeichne(
        this,
        farbe,
        new Rectangle(xPosition, yPosition, xgroesse, ygroesse),
        gefuellt);
      leinwand.warte(10);
    }
  }

  /*
   * Loesche dieses Rechteck vom Bildschirm.
   */
  private void loeschen()
  {
    if (istSichtbar)
    {
      Leinwand leinwand = Leinwand.gibLeinwand();
      leinwand.entferne(this);
    }
  }
}
