import java.awt.Shape;

/**
 * Ein allgemeines Mbelstck, als Grundlage fr Vererbung.
 * 
 * @author Java-MS Groupies
 * hier Uwe Debacher
 * nach Vorlagen von Michael Klling und David J. Barnes und Axel Schmolitzky
 * @version 1.1  (23.2.04)
 */
abstract public class Moebelstueck
{
  public int xPosition;
  public int yPosition;
  public int orientierung;
  public String farbe;
  public boolean istSichtbar;

   /**
   * Erzeuge ein Moebelstueck mit einer Standardfarbe an einer
   * Standardposition.
   */
	public Moebelstueck()
	{
    xPosition = 160;
    yPosition = 80;
    farbe = "blau";
    orientierung = 0;
    istSichtbar = false;	
    }

  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   * [ Zum Anzeigen der Attributwerte ber Inspect muss hier die Sichtbarkeit 
   *  auf public gesetzt werden. ]
   */
  abstract public Shape gibAktuelleFigur();

  /**
   * Mache dieses Objekt sichtbar. Wenn es bereits sichtbar ist, tue
   * nichts.
   */
  public void zeige()
  {
    istSichtbar = true;
    zeichne();
  }

  /**
   * Mache dieses Objekt unsichtbar. Wenn es bereits unsichtbar ist, tue
   * nichts.
   */
  public void verberge()
  {
    loesche();
    istSichtbar = false;
  }

  /**
   * Drehe auf den angegebenen Winkel
   */
  public void dreheAuf(int neuerWinkel)
  {
     loesche();
     orientierung = neuerWinkel;
     zeichne();
  }

  /**
   * Bewege dieses Objekt horizontal um 'entfernung' Bildschirmpunkte.
   */
  public void bewegeHorizontal(int entfernung)
  {
    loesche();
    xPosition += entfernung;
    zeichne();
  }

  /**
   * Bewege dieses objekt vertikal um 'entfernung' Bildschirmpunkte.
   */
  public void bewegeVertikal(int entfernung)
  {
    loesche();
    yPosition += entfernung;
    zeichne();
  }

 
  /**
   * ndere die Farbe dieses Objektes in 'neueFarbe'.
   * Gltige Angaben sind "rot", "gelb", "blau", "gruen",
   * "lila" und "schwarz".
   */
  public void aendereFarbe(String neueFarbe)
  {
    farbe = neueFarbe;
    zeichne();
  }

  /*
   * Zeichne dieses Objekt mit seinen aktuellen Werten auf den Bildschirm.
   */
  private void zeichne()
  {
    if (istSichtbar)
    {
      Shape figur = gibAktuelleFigur();
      Leinwand leinwand = Leinwand.gibLeinwand();
      leinwand.zeichne (
        this,
        farbe,
        figur);
      leinwand.warte(10);
    }
  }

  /*
   * Lsche dieses Objekt vom Bildschirm.
   */
  private void loesche()
  {
    if (istSichtbar)
    {
      Leinwand leinwand = Leinwand.gibLeinwand();
      leinwand.entferne(this);
    }
  }


}
