import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;


/**
 * Ein Stuhl, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Java-MS Groupies
 * hier claus albowski
 * nach einer Vorlage von Uwe Debacher,
 * Michael Klling und David J. Barnes und Axel Schmolitzky
 * @version 1.1  (8.2.04)
 */
public class Stuhl extends Moebelstueck 
{
  private int breite;
  private int tiefe;


  /**
   * Erzeuge einen neuen Stuhl mit einer Standardfarbe an einer
   * Standardposition.
   */
	public Stuhl()
  {
    super();
    breite = 40;
    tiefe  = 40;
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   * [ Zum Anzeigen der Attributwerte ber Inspect muss hier die Sichtbarkeit 
   *  auf public gesetzt werden. ]
   */
  public Shape gibAktuelleFigur()
  {
      GeneralPath stuhl = new GeneralPath();
      stuhl.moveTo(xPosition       , yPosition);
      stuhl.lineTo(xPosition+breite, yPosition);
      stuhl.lineTo(xPosition+breite+3, yPosition+tiefe);
      stuhl.lineTo(xPosition-3       , yPosition+tiefe);
      stuhl.lineTo(xPosition       , yPosition        );
      //Das ist die Umrandung. Das Stuhl bekommt noch eine Lehne
      stuhl.moveTo(xPosition       , yPosition + 5 );
      stuhl.lineTo(xPosition + breite      , yPosition + 5);

      AffineTransform t1 = new AffineTransform();
      t1.rotate(Math.toRadians(orientierung),gibMitteX(),gibMitteY());

      return  t1.createTransformedShape(stuhl);
  }
  
  /**
   * Hole die X-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteX()
  {
    return xPosition+breite/2;
  }

  /**
   * Hole die Y-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteY()
  {
    return yPosition+tiefe/2;
  }

}
