import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;

/**
 * Ein Stuhl, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Java-MS Groupies
 * hier Uwe Debacher,
 * Michael Klling und David J. Barnes und Axel Schmolitzky
 * @version 1.1  (5.5.04)
 */

public class Sitzgruppe extends Moebelstueck
{
    private int breite;
    private int tiefe;
    private Tisch tisch;
    private Stuhl stuhl1;
    private Stuhl stuhl2;
    private Stuhl stuhl3;
    private Stuhl stuhl4;
    
  /**
   * Konstruktor fr Objekte der Klasse Sitzgruppe
   */
  public Sitzgruppe()
  {
     super();
     breite=220;
     tiefe=230;
         
     tisch = new Tisch();
     tisch.bewegeHorizontal(xPosition+70);
     tisch.bewegeVertikal(yPosition+70);

     stuhl1 = new Stuhl();
     stuhl1.bewegeHorizontal(xPosition+110);
     stuhl1.bewegeVertikal(yPosition+10);
     stuhl1.dreheAuf(0);

     stuhl2 = new Stuhl();
     stuhl2.bewegeHorizontal(xPosition+10);
     stuhl2.bewegeVertikal(yPosition+100);
     stuhl2.dreheAuf(270);

     stuhl3 = new Stuhl();
     stuhl3.bewegeHorizontal(xPosition+110);
     stuhl3.bewegeVertikal(yPosition+190);
     stuhl3.dreheAuf(180);

     stuhl4 = new Stuhl();
     stuhl4.bewegeHorizontal(xPosition+210);
     stuhl4.bewegeVertikal(yPosition+100);
     stuhl4.dreheAuf(90);
  }

  /**
   * Mache dieses Objekt sichtbar. Wenn es bereits sichtbar ist, tut
   * sich nichts.
   */
  public void zeige()
  {
    istSichtbar = true;
    tisch.zeige();
    stuhl1.zeige();
    stuhl2.zeige();
    stuhl3.zeige();
    stuhl4.zeige();
  }

  /**
   * Mache dieses Objekt unsichtbar. Wenn es bereits unsichtbar ist, tut
   * sich nichts.
   */
  public void verberge()
  {
    istSichtbar = false;
    tisch.verberge();
    stuhl1.verberge();
    stuhl2.verberge();
    stuhl3.verberge();
    stuhl4.verberge();
    
  }

  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   * [ Zum Anzeigen der Attributwerte ber Inspect muss hier die Sichtbarkeit 
   *  auf public gesetzt werden. ]
   */
  public  Shape gibAktuelleFigur()
  {
     GeneralPath sitzgruppe = new GeneralPath();
     sitzgruppe.append( tisch.gibAktuelleFigur(), false);
     sitzgruppe.append( stuhl1.gibAktuelleFigur(), false);
     sitzgruppe.append( stuhl2.gibAktuelleFigur(), false);
     sitzgruppe.append( stuhl3.gibAktuelleFigur(), false);
     sitzgruppe.append( stuhl4.gibAktuelleFigur(), false);

     AffineTransform t1 = new AffineTransform();
     t1.rotate(Math.toRadians(orientierung),gibMitteX(),gibMitteY());

     return  t1.createTransformedShape(sitzgruppe);
    }
    
  public void bewegeVertikal(int entfernung)
  {
     tisch.bewegeVertikal(entfernung);
     stuhl1.bewegeVertikal(entfernung);
     stuhl2.bewegeVertikal(entfernung);
     stuhl3.bewegeVertikal(entfernung);
     stuhl4.bewegeVertikal(entfernung);    
  }    
    
    
  /**
   * Hole die X-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteX()
  {
    return xPosition+breite/2;
  }

  /**
   * Hole die Y-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteY()
  {
    return yPosition+tiefe/2;
  }


}
