import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import java.awt.geom.Ellipse2D;
import java.awt.Graphics2D;

/**
 * Ein Tisch, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Java-MS Groupies
 * hier claus albowski
 * nach einer Vorlage von Uwe Debacher,
 * Michael Klling und David J. Barnes und Axel Schmolitzky
 * @version 1.1  (8.2.04)
 */
public class Tisch extends Moebelstueck
{

  private int breite;
  private int tiefe;


  /**
   * Erzeuge einen neuen Tisch mit einer Standardfarbe an einer
   * Standardposition.
   */
	public Tisch()
  {
    breite = 120;
    tiefe  = 100;
  }
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   * [ Zum Anzeigen der Attributwerte ber Inspect muss hier die Sichtbarkeit 
   *  auf public gesetzt werden. ]
   */
  public Shape gibAktuelleFigur()
  {
      Shape tisch = new Ellipse2D.Double(xPosition , yPosition, breite, tiefe);

      AffineTransform t1 = new AffineTransform();
      t1.rotate(Math.toRadians(orientierung),gibMitteX(),gibMitteY());

      return  t1.createTransformedShape(tisch);
  }
  
  /**
   * Hole die X-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteX()
  {
    return xPosition+breite/2;
  }

  /**
   * Hole die Y-Koordinate des Mittelpunktes
   * [ Hilfsfunktion fr das Drehen. ]
   */
  private int gibMitteY()
  {
    return yPosition+tiefe/2;
  }

}
