import java.util.ArrayList;

/**
 * Eine Klasse zur Verwaltung von beliebig langen Notizlisten.
 * Notizen sind nummeriert, um durch einen Benutzer referenziert
 * werden zu knnen.
 * In dieser Version starten die Notiznummern bei 0.
 * 
 * @author David J. Barnes and Michael Kolling.
 * @version 2003.04.15
 */
public class Notizbuch
{
    // Speicher fr eine beliebige Anzahl an Notizen.
    private ArrayList notizen;

    /**
     * Fhre die Initialisierungen durch, die fr ein Notizbuch
     * notwendig sind.
     */
    public Notizbuch()
    {
        notizen = new ArrayList();
    }

    /**
     * Speichere eine neue Notiz in diesem Notizbuch.
     * @param notiz die zu speichernde Notiz.
     */
    public void speichereNotiz(String notiz)
    {
        notizen.add(notiz);
    }

    /**
     * @return die Anzahl der Notizen in diesem Notizbuch.
     */
    public int anzahlNotizen()
    {
        return notizen.size();
    }

    /**
     * Zeige eine Notiz.
     * @param notiznummer die Nummer der Notiz, die gezeigt werden soll.
     */
    public void zeigeNotiz(int notiznummer)
    {
        if(notiznummer < 0) {
            // Keine gltige Nummer, nichts zu tun.
        }
        else if(notiznummer < anzahlNotizen()) {
            // Die Nummer ist gltig, wir knnen die Notiz ausgeben.
            System.out.println(notizen.get(notiznummer));
        }
        else {
            // Keine gltige Nummer, nichts zu tun.
        }
    }

    /**
     * Gib alle Notizen dieses Notizbuchs auf die Konsole aus.
     */
    public void zeigeNotiz()
    {
        int index = 0;
        while(index < notizen.size()) {
            System.out.println(notizen.get(index));
            index++;
        }
    }
    
    /**
     * Zeige eine Notiz.
     * @param Text der Notiz, die gezeigt werden soll.
     */
    public void zeigeNotiz(String vergleichstext)
    {
        int index = 0;
        while(index < notizen.size()) {
          if (vergleichstext.equals(notizen.get(index))) {
            System.out.println(notizen.get(index));
        }  
        index++;
        }
    }

    /**
     * Entferne die Notiz mit der angegebenen Nummer aus
     * diesem Notizbuch, wenn sie existiert.
     * @param notiznummer die Nummer der zu entfernenden Notiz.
     */
    public void entferneNotiz(int notiznummer)
    {
        if(notiznummer < 0) {
            // Keine gltige Nummer, nichts zu tun.
        }
        else if(notiznummer < anzahlNotizen()) {
            // Die Notiznummer ist gltig.
            notizen.remove(notiznummer);
        }
        else {
            // Keine gltige Nummer, nichts zu tun.
        }
    }
   
    /**
     * Entfernt alle Notizen dieses Notizbuches.
     */
    public void entferneNotiz()
    {
        notizen.clear();
    }
    
    /**
     * Entfernt die Notiz mit dem angegebenen Text.
     * @param Text der Notiz, die entfernt werden soll.
     */
    public void entferneNotiz(String vergleichstext)
    {
        int index=0;
        while (index<anzahlNotizen()) {
            if (vergleichstext.equals(notizen.get(index))) {
                entferneNotiz(index);
                break;
            }
        }
    }

}
