import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import java.util.ArrayList;


/**
 * 
 * @author Java-MS Groupies
 * hier claus albowski
 * nach einer Vorlage von Uwe Debacher,
 * Michael K�lling und David J. Barnes und Axel Schmolitzky
 * letzte Bearbeitung Uwe Debacher
 * @version 1.2  (1.6.04)
 */

public class Sitzgruppe extends Moebelstueck
{
    // Instanzvariablen 
    private int breite;
    private int tiefe;
    private ArrayList bestandteile;
    
    /**
     * Konstruktor f�r Objekte der Klasse Sitzgruppe
     */
    public Sitzgruppe()
    {
        // Instanzvariablen initialisieren
         super();
         breite=220;
         tiefe=230;
         bestandteile = new ArrayList();
         Moebelstueck hilf;
         
         hilf = new Tisch();
         hilf.bewegeHorizontal(xPosition+70);
         hilf.bewegeVertikal(yPosition+70);
         bestandteile.add(hilf);

         hilf = new Stuhl();
         hilf.bewegeHorizontal(xPosition+110);
         hilf.bewegeVertikal(yPosition+10);
         hilf.dreheAuf(0);
         bestandteile.add(hilf);

         hilf = new Stuhl();
         hilf.bewegeHorizontal(xPosition+10);
         hilf.bewegeVertikal(yPosition+100);
         hilf.dreheAuf(270);
         bestandteile.add(hilf);

         hilf = new Stuhl();
         hilf.bewegeHorizontal(xPosition+110);
         hilf.bewegeVertikal(yPosition+190);
         hilf.dreheAuf(180);
         bestandteile.add(hilf);

         hilf = new Stuhl();
         hilf.bewegeHorizontal(xPosition+210);
         hilf.bewegeVertikal(yPosition+100);
         hilf.dreheAuf(90);
         bestandteile.add(hilf);
    }

  
  public  Shape gibAktuelleFigur()
  {
    GeneralPath sitzgruppe = new GeneralPath();

    for (int index=0; index<bestandteile.size(); index=index+1) {
      sitzgruppe.append(( (Moebelstueck) bestandteile.get(index)).gibAktuelleFigur(), false);
    }  
  
    AffineTransform t1 = new AffineTransform();
    t1.rotate(Math.toRadians(orientierung),gibMitteX(),gibMitteY());
    t1.translate(xPosition, yPosition);
    return  t1.createTransformedShape(sitzgruppe);
    }
    
    
    
  /**
   * Hole die X-Koordinate des Mittelpunktes
   * [ Hilfsfunktion f�r das Drehen. ]
   */
  private int gibMitteX()
  {
    return xPosition+breite/2;
  }

  /**
   * Hole die Y-Koordinate des Mittelpunktes
   * [ Hilfsfunktion f�r das Drehen. ]
   */
  private int gibMitteY()
  {
    return yPosition+tiefe/2;
  }

  public void neuerBestandteil(Moebelstueck komponente)
  {
    bestandteile.add(komponente);    
    zeichne(); 
      }    


}
